unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,ShellApi, OleCtrls, voicerlibLib_TLB, ExtCtrls;

  function dg_TxRxMixEnable(Port:Smallint ; Enable:Smallint): Smallint; cdecl; external 'voicerlib.dll';

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    btnIniciaDriver: TButton;
    btnCriaThread: TButton;
    btnFinalizaDriver: TButton;
    btnDestroiThread: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    txtID: TEdit;
    Label2: TLabel;
    txtMaxGravacao: TEdit;
    voicerlib1: Tvoicerlib;
    Label3: TLabel;
    txtPorta: TEdit;
    txtTempoSilencio: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    txtLimiar: TEdit;
    Image1: TImage;
    btnLeiaMe: TButton;
    Panel3: TPanel;
    lblStatus: TLabel;
    lblStatus1: TLabel;
    btnLimpaLog: TButton;
    procedure btnCriaThreadClick(Sender: TObject);
    procedure btnDestroiThreadClick(Sender: TObject);
    procedure btnLimpaLogClick(Sender: TObject);
    procedure btnIniciaDriverClick(Sender: TObject);
    procedure btnFinalizaDriverClick(Sender: TObject);
    procedure voicerlib1RingDetected(ASender: TObject; Port: Smallint);
    procedure voicerlib1AfterPickup(ASender: TObject; Port: Smallint);
    procedure voicerlib1PlayStop(ASender: TObject; Port,
      StopStatus: Smallint);
    procedure voicerlib1RecordStop(ASender: TObject; Port,
      StopStatus: Smallint);
    procedure voicerlib1BusyDetected(ASender: TObject; Port: Smallint);
    procedure voicerlib1Recording(ASender: TObject; Port: Smallint;
      ElapsedTime: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnLeiaMeClick(Sender: TObject);
    procedure voicerlib1CallerID(ASender: TObject; Port: Smallint;
      const Number: WideString);
    procedure voicerlib1E1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
      AlarmData: Smallint);
    procedure voicerlib1E1StateChange(ASender: TObject; Port,
      State: Smallint);
    procedure voicerlib1SilenceDetected(ASender: TObject; Port,
      State: Smallint);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  nTotalPortas : Integer;
  nTotalPlacas : Integer;
  nFlag : Integer;
  sReturn    : array [0..255] of Char;

implementation

{$R *.dfm}

//**********************************************************
//Esta procedure coloca na tela os estados do programa
//com hora e a porta
//**********************************************************
procedure MostraStatus(nPorta: integer; sMess: string);
var
  sMsg: string;
begin
  if (nPorta > 0) then
    sMsg := '<' + TimeToStr(Time) + '> - (Porta ' + IntToStr(nPorta) + ') - ' +sMess
  else
    sMsg := '<' + TimeToStr(Time) + '> - ' + sMess;
  Form1.Memo1.Lines.Add(sMsg);
end;

//**********************************************************
//Cria uma thread de tratamento E1 para cada canal da placa
//**********************************************************
procedure TForm1.btnCriaThreadClick(Sender: TObject);
var
  nRet,i,j,k : Integer;
begin
  try
    for j:=1 to voicerlib1.GetPortsCount do
    begin
      //Cria thread do protocolo R2D
      nRet := voicerlib1.CreateE1Thread(j);

      case nRet of
        DG_EXIT_SUCCESS:
          MostraStatus(j,'Thread E1 iniciada com sucesso');

        DG_ERROR_DRIVER_CLOSED:
          MostraStatus(j,'O driver no foi iniciado');

        DG_ERROR_THREAD_ALREADY_RUNNING:
          MostraStatus(j,'A thread j havia sido iniciada anteriormente');

        DG_FEATURE_NOT_SUPPORTED:
          MostraStatus(j,'Comando enviado para uma placa FXO e no E1');

        DG_ERROR_FIFO_UNAVAILABLE:
          MostraStatus(j,'Erro na criao da estrutura de comunicao da thread');

        DG_ERROR_COULD_NOT_CREATE_THREAD:
          MostraStatus(j,'Falha na inicializao da thread');

      end;
    end;

    for i:=1 to voicerlib1.GetCardsCount do
    begin
      //Configura o sincronismo
      voicerlib1.SetCardSyncMode(i, SYNC_LINE_A);
      //Configura para que o evento OnE1Alarm ocorra automaticamente sempre quando um alarme for detectado
      voicerlib1.SetAlarmMode(i, ALARM_AUTOMATIC_NOTIFY);
    end;

    for k:=1 to voicerlib1.GetPortsCount do
    begin
      //Categoria do Assinante
      voicerlib1.ConfigE1Thread(k, E1CFG_GROUP_II,1);
      //Seta o Bina
      voicerlib1.SetPortID(k, '1121916363');
      //Numero total de digitos a receber
      voicerlib1.ConfigE1Thread(k, E1CFG_MAXDIGITS_RX,4);
      //Status Grupo B
      voicerlib1.ConfigE1Thread(k, E1CFG_GROUP_B,1);
      //Em ligacoes de entrada, pede bina apos o 2 digito
      voicerlib1.ConfigE1Thread(k, E1CFG_SEND_ID_AFTERDIGIT,2);
      voicerlib1.TxRxMixEnable(k,DG_ENABLE);
    end;

  except
    Application.MessageBox('Erro na criao das Threads E1', 'Except', mb_OK);
  end;
end;

//**********************************************************
//Destroi as threads de tratamento E1 de cada canal da placa
//**********************************************************
procedure TForm1.btnDestroiThreadClick(Sender: TObject);
var
  nRet,i : Integer;
begin
  try
     if voicerlib1.DriverEnabled = TRUE then
     begin
      //Desabilita amostras de audio
      nRet := voicerLib1.DisableInputBuffer(StrToInt(txtPorta.Text));
      if nRet = DG_EXIT_SUCCESS then
        MostraStatus(StrToInt(txtPorta.Text),'InputBuffer desabilitado com sucesso')
      else
        MostraStatus(StrToInt(txtPorta.Text),'Erro ao desabilitar InputBuffer.nRet ' + IntToStr(nRet));

      for i:=1 to voicerlib1.GetPortsCount do
      begin
        //Destroi as Threads
        if voicerlib1.DestroyE1Thread(i) <> DG_EXIT_SUCCESS then
          MostraStatus(i,'Erro ao destruir thread E1.nRet ' + IntToStr(nRet))
        else
          MostraStatus(i,'Destruiu thread E1') ;
      end;

      txtPorta.Enabled := True;
     end;
  except
    Application.MessageBox('Erro ao destruir as threads E1', 'Except', mb_OK);
  end;
end;

//*********************************************
//Limpa tela de Log
//*********************************************
procedure TForm1.btnLimpaLogClick(Sender: TObject);
begin
  Memo1.Clear;
end;

//***********************************************
// Inicia VoicerLib
//***********************************************
procedure TForm1.btnIniciaDriverClick(Sender: TObject);
var
  nRet, nRet1, i:Integer;
begin
  nFlag := 0 ;

  if voicerlib1.DriverEnabled then
    MostraStatus(0,'Driver j inicializado')
  else
  begin
    //Inicializa a placa
    nRet := voicerlib1.StartVoicerLib;
    //Trata o retorno da inicializacao
    voicerlib1.ReturnCodeToString(nRet,Cardinal(@sReturn));    

    //Testa o retorno do StartVoicerLib
    if nRet = DG_EXIT_SUCCESS then
    begin
      MostraStatus(0,'VoicerLib inicializada com Sucesso');
      //Habilita o recurso de depuracao da VoicerLib
      voicerlib1.EnableDebug(623);
      nTotalPortas := voicerlib1.GetPortsCount ;
      nTotalPlacas := voicerlib1.GetCardsCount ;
      lblStatus.Caption := 'Nmero Total de Placas: ' + IntToStr(nTotalPlacas) ;
      lblStatus1.Caption := 'Nmero Total de Portas: ' + IntToStr(nTotalPortas) ;
      btnIniciaDriver.Enabled := False ;
      btnFinalizaDriver.Enabled := True;
      txtPorta.Enabled := False;

      for i := 1 to voicerlib1.GetPortsCount do
      begin
        //Permite alterar o limiar para deteco de atendimento
        nRet1 := voicerlib1.SetSilenceThreshold(i,StrToInt(txtLimiar.Text));
        if nRet1 <> DG_EXIT_SUCCESS then
          MostraStatus(i,'Erro ao setar o limiar de silncio.nRet :' + IntToStr(nRet1));

        //Cria thread de callprogress
        nRet1 := voicerlib1.CreateCallProgress(i,'cp_default.cfg');
        if nRet1 <> DG_EXIT_SUCCESS then
          MostraStatus(i,'Erro ao criar superviso de linha.nRet :' + IntToStr(nRet1));
      end;
    end
    else
      MostraStatus(0,'Erro ao iniciar a VoicerLib.nRet ' + sReturn); 
  end;
end;

//*********************************************
//Finaliza VoicerLib
//*********************************************
procedure TForm1.btnFinalizaDriverClick(Sender: TObject);
var
  nRet,i : integer;
begin

  if VoicerLib1.DriverEnabled then
  begin
    for i:=1 to voicerlib1.GetPortsCount do
    begin
      //Finaliza a supervisao de linha
      nRet := voicerlib1.DestroyCallProgress(i);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(i,'Erro ao destruir superviso de linha.nRet ' + IntToStr(nRet)) 
    end;

    //Desabilita a deteccao de silencio
    nRet := voicerlib1.DisableSilenceDetection(StrToInt(txtPorta.Text));
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(StrToInt(txtPorta.Text),'Erro ao desabilitar deteco de silncio.nRet ' + IntToStr(nRet)); 

    //Desliga a Placa
    nRet:= voicerlib1.ShutdownVoicerLib;
    //Testa se desligou corretamente
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(0,'Erro na finalizao. Recomenda-se reiniciar o micro.nRet ' + IntToStr(nRet)) 
    else
    begin
      MostraStatus(0,'Placa finalizada com sucesso');
      btnIniciaDriver.Enabled := True;
      btnFinalizaDriver.Enabled := False;
      txtPorta.Enabled := True;
    end;
  end;
end;

//******************************************************
// Recebe Ring e atende chamada - Aguarda Evento OnAfterPickup
//******************************************************
procedure TForm1.voicerlib1RingDetected(ASender: TObject; Port: Smallint);
var
  nRet : Integer;
begin
  try
    //Atende a porta
    nRet := voicerlib1.PickUp(Port,1000);
    if nRet = DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnRingDetected) - Atendeu a porta...')
    else
      MostraStatus(Port,'(OnRingDetected) - Erro ao atender a porta.nRet ' + IntToStr(nRet));

  except
    Application.MessageBox('(OnRingDetected) - Erro ao atender a porta', 'Except', mb_OK);
  end;
end;

//**************************************
// Reproduz mensagem - Aguarda PlayStop
//**************************************
procedure TForm1.voicerlib1AfterPickup(ASender: TObject; Port: Smallint);
var
  sArq : string;
  nRet : Integer;
begin
  try
    sArq := extractFilePath(Application.exename) + 'Fraseatendimento_PCM.wav';

    //Especifica o formato de gravacao
    nRet := VoicerLib1.SetRecordFormat(Port,ffWavePCM);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnPlayStop) - Erro ao setar o formato de gravao.nRet ' + IntToStr(nRet)) ;

    //Habilita o envio de amostras da placa para a aplicao
    nRet := voicerlib1.EnableInputBuffer(Port,DG_ENABLE_AGC);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnPlayStop) - Erro ao habilitar inputbuffer.nRet ' + IntToStr(nRet)) ;

    nFlag := 0 ;
    sleep(200);
    //Inicia gravao de Recado
    nRet :=  voicerLib1.RecordFile(Port,extractFilePath(Application.exename) +'gravacao.wav','');
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnPlayStop) - Erro ao iniciar gravao.nRet ' + IntToStr(nRet))
    else
      MostraStatus(Port,'(OnPlayStop) - Iniciou gravao. Gravando mensagem em ' + extractFilePath(Application.exename) +'gravacao.wav');
     sleep(2000);
    //Reproduz mensagem de atendimento
    if VoicerLib1.PlayFile(Port,sArq,'567',0) = DG_EXIT_SUCCESS then
    begin
      MostraStatus(Port,'(OnAfterPickup) - Reproduzindo mensagem ' + sArq);












    end
    else
    begin
      MostraStatus(Port,'(OnAfterPickup) - Arquivo '+ sArq + ' no encontrado...');

      //Desliga a porta
      nRet := voicerlib1.HangUp(Port);
      if nRet = DG_EXIT_SUCCESS then  
        MostraStatus(Port, '(OnAfterPickup) - Desligou a porta')
      else
        MostraStatus(Port,'(OnAfterPickup) - Erro ao desligar.nRet ' + IntToStr(nRet)); 

      //Desabilita supervisao de linha
      nRet := voicerlib1.DisableCallProgress(Port); 
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(Port,'(OnAfterPickup) - Erro ao desabilitar superviso de linha.nRet ' + IntToStr(nRet)) ;

      //Desabilita deteccao de silencio
      nRet := voicerlib1.DisableSilenceDetection(Port);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(Port,'(OnAfterPickup) - Erro ao desabilitar a deteco de silncio.nRet ' + IntToStr(nRet)) ;
    end;

  except
    Application.MessageBox('(OnAfterPickup) - Erro no OnAfterPickup', 'Except', mb_OK);
  end;
end;

//*********************************************
//Este evento  gerado aps o trmino de uma
//reproduo de frase
//*********************************************
procedure TForm1.voicerlib1PlayStop (ASender: TObject; Port,
  StopStatus: Smallint);
var
  nRet : Integer;
begin
  if StopStatus = ssNormal then
  begin
    {//Especifica o formato de gravacao
    nRet := VoicerLib1.SetRecordFormat(Port,ffWavePCM);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnPlayStop) - Erro ao setar o formato de gravao.nRet ' + IntToStr(nRet)) ;

    //Habilita supervisao de linha
    nRet := voicerlib1.EnableCallProgress(Port,CP_ENABLE_BUSY_OR_FAX);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnPlayStop) - Erro ao habilitar superviso de linha CP_ENABLE_BUSY_OR_FAX.nRet ' + IntToStr(nRet))
    else
      MostraStatus(Port,'(OnPlayStop) - Habilitou superviso de linha CP_ENABLE_BUSY_OR_FAX');

    //Habilita o envio de amostras da placa para a aplicao
    nRet := voicerlib1.EnableInputBuffer(Port,DG_ENABLE);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnPlayStop) - Erro ao habilitar inputbuffer.nRet ' + IntToStr(nRet)) ;

    nFlag := 0 ;

    //Desabilita o tempo de silencio caso esteja habilitado em testes seguidos
    nRet := voicerlib1.DisableSilenceDetection(Port);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnPlayStop) - Erro ao desabilitar a deteco de silncio.nRet ' + IntToStr(nRet)) ;

    //Habilita deteccao de silencio
    nRet := voicerlib1.EnableSilenceDetection(Port,StrToInt(txtTempoSilencio.Text),100);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnPlayStop) - Erro ao habilitar a deteco de silncio.nRet ' + IntToStr(nRet)) ;

    //Inicia gravao de Recado
    nRet :=  voicerLib1.RecordFile(Port,extractFilePath(Application.exename) +'gravacao.wav','');
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnPlayStop) - Erro ao iniciar gravao.nRet ' + IntToStr(nRet))
    else
      MostraStatus(Port,'(OnPlayStop) - Iniciou gravao. Gravando mensagem em ' + extractFilePath(Application.exename) +'gravacao.wav'); }

  end;
end;

//*************************************************
//este evento  gerado logo aps se mandar parar
//uma gravao
//*************************************************
procedure TForm1.voicerlib1RecordStop(ASender: TObject; Port,
  StopStatus: Smallint);
var
  nRet : Integer;

begin
  //Desabilita as amostras de audio
  nRet := voicerlib1.DisableInputBuffer(Port);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(Port,'(OnRecordStop) - InputBuffer desabilitado')
  else
    MostraStatus(Port,'(OnRecordStop) - Erro ao desabilitar inputbuffer.nRet ' + IntToStr(nRet));

  //Desliga a porta
  nRet := voicerlib1.HangUp(Port);
  if nRet = DG_EXIT_SUCCESS then  
    MostraStatus(Port, '(OnRecordStop) - Desligou a porta')
  else
    MostraStatus(Port,'(OnRecordStop) - Erro ao desligar a porta.nRet ' + IntToStr(nRet)); 
  
  //Desabilita supervisao de linha
  nRet := voicerlib1.DisableCallProgress(Port); 
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(Port,'(OnRecordStop) - Erro ao desabilitar superviso de linha.nRet ' + IntToStr(nRet)) ;

  //Desabilita deteccao de silencio
  nRet := voicerlib1.DisableSilenceDetection(Port);
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(Port,'(OnRecordStop) - Erro ao desabilitar a deteco de silncio.nRet ' + IntToStr(nRet)) ;
  
end;

//**********************************************************
//No desligamento do assinante chamador a VoicerLib
//gera um evento Onbusy que deve ser utilizado para parar
//a gravao
//**********************************************************
procedure TForm1.voicerlib1BusyDetected(ASender: TObject; Port: Smallint);
var
  nRet : integer;
begin

  //Testa se esta falando a mensagem inicial
  if voicerlib1.IsPlaying(Port) then
  begin
    //Pra de falar a frase
    nRet := voicerlib1.StopPlayFile(Port);
    if nRet = DG_EXIT_SUCCESS then  
      MostraStatus(Port,'(OnBusyDetected) - Assinante A desligou. Parando a reproduo da frase...');

    //Desliga a porta
    nRet := voicerlib1.HangUp(Port);
    if nRet = DG_EXIT_SUCCESS then  
      MostraStatus(Port, '(OnBusyDetected) - Desligou a porta')
    else
      MostraStatus(Port,'(OnBusyDetected) - Erro ao desligar a porta.nRet ' + IntToStr(nRet)); 
  
    //Desabilita CallProgress
    nRet := voicerlib1.DisableCallProgress(Port); 
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnBusyDetected) - Erro ao desabilitar superviso de linha.nRet ' + IntToStr(nRet)) ;

    //Desabilita deteccao de silencio
    nRet := voicerlib1.DisableSilenceDetection(Port);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnBusyDetected) - Erro ao desabilitar a deteco de silncio.nRet ' + IntToStr(nRet)) ;
  end
  else
  begin
    //Testa se ainda est gravando
    if voicerlib1.IsRecording(Port) then
    begin
      //Pra a gravacao
      nRet := VoicerLib1.StopRecordFile(Port);
      if nRet = DG_EXIT_SUCCESS then 
        MostraStatus(Port,'(OnBusyDetected) - Assinante A desligou...Parando a gravao...');
    end;
  end;
end;


//*********************************************
//Durante a gravao a VoicerLib envia a cada
//segundo este evento com o tempo de gravao
//*********************************************
procedure TForm1.voicerlib1Recording(ASender: TObject; Port: Smallint;
  ElapsedTime: Integer);
var
  nMaxRecTime, nRet: integer;
begin
  //le tempo mximo de gravao
  nMaxRecTime := strToInt(txtMaxGravacao.text);

  //testa se atingiu limite
  if (ElapsedTime >= nMaxRecTime) and (nFlag = 0)then
  begin
    nFlag := 1;
    //Pra a gravacao
    nRet := VoicerLib1.StopRecordFile(Port);
    if nRet = DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnRecording) - Parando a gravao por tempo mximo')
    else
      MostraStatus(Port,'(OnRecording) - Erro ao parar a gravao por tempo mximo.nRet ' + IntToStr(nRet));      

    //Desliga a porta
    nRet := voicerlib1.HangUp(Port);
    if nRet = DG_EXIT_SUCCESS then  
      MostraStatus(Port, '(OnRecording) - Desligou a porta')
    else
      MostraStatus(Port,'(OnRecording) - Erro ao desligar a porta.nRet ' + IntToStr(nRet)); 
  
    //Desabilita supervisao de linha
    nRet := voicerlib1.DisableCallProgress(Port); 
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnRecording) - Erro ao desabilitar superviso de linha.nRet ' + IntToStr(nRet)) ;

    //Desabilita deteccao de silencio
    nRet := voicerlib1.DisableSilenceDetection(Port);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnRecording) - Erro ao desabilitar a deteco de silncio.nRet ' + IntToStr(nRet)) ;
    
    //Desabilita as amostras de audio
    nRet := voicerlib1.DisableInputBuffer(Port);
    if nRet = DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnRecording) - InputBuffer desabilitado com sucesso')
    else
      MostraStatus(Port,'(OnRecording) - Erro ao desabilitar inputbuffer.nRet ' + IntToStr(nRet));

  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //Verifica se o driver esta inicializado
  if VoicerLib1.DriverEnabled then
  begin
    Application.Messagebox('Finalize a VoicerLib antes de fechar a aplicao','Aviso',MB_OK + MB_ICONSTOP);
    CanClose := false;
  end;
end;

procedure TForm1.btnLeiaMeClick(Sender: TObject);
var
  L:String;
begin
  L:= ExtractFilePath(Application.ExeName) + 'Leiame.txt';
  ShellExecute(0 ,nil,PChar(L), nil, nil,SW_NORMAL);
end;


//*********************************************
//Mostra na tela o nmero do assinante A(Bina)
//*********************************************
procedure TForm1.voicerlib1CallerID(ASender: TObject; Port: Smallint;
  const Number: WideString);
begin
  txtID.Text := Number;
end;

procedure TForm1.voicerlib1E1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
  AlarmData: Smallint);
begin

  case AlarmCode of
    ALARM_RSLIP:
      MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Escorregamento (problema de sincronismo) - ' + IntToStr(AlarmCode));

    ALARM_RAIS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Alarme remoto ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Alarme remoto OFF');
    end;

    ALARM_AISS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme OFF');
    end;

    ALARM_AIS16S:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 OFF');
    end;

    ALARM_LOSS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Perda de sinal ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Perda de sinal OFF');
    end;

    ALARM_CRC4SYNC:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Reservado ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Reservado OFF');
    end;

    ALARM_MFSYNC:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro OFF');
    end;

    ALARM_SYNC:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro OFF');
    end;
  end;
end;

procedure TForm1.voicerlib1E1StateChange(ASender: TObject; Port,
  State: Smallint);
begin
  case State of
    C_SEIZURE:
      MostraStatus(Port,'(OnE1StateChange) - E1 Ocupao');

    C_NUMBER_RECEIVED:
      MostraStatus(Port,'(OnE1StateChange) - E1 Nmero Recebido -> ' + voicerlib1.GetE1Number(Port));

    C_CONGESTION:
      MostraStatus(Port,'(OnE1StateChange) - E1 Congestionamento');

    C_B_ENDCALL:
       MostraStatus(Port,'(OnE1StateChange) - E1 Fim da Chamada');

    C_NOTCOMPLETED:
       MostraStatus(Port,'(OnE1StateChange) - E1 No completada');

    C_GROUP_II:
       MostraStatus(Port,'(OnE1StateChange) - E1 Categoria');

    C_UNAVAILABLE:
       MostraStatus(Port,'(OnE1StateChange) - E1 No disponvel');

    else
      MostraStatus(Port,'(OnE1StateChange) - E1 State -> ' + IntToStr(State));
  end;
end;

procedure TForm1.voicerlib1SilenceDetected(ASender: TObject; Port,
  State: Smallint);
var
  nRet : Integer;
begin

  //Verifica se detectou silencio, se sim desliga
  if State = DG_SILENCE_DETECTED then
  begin
    MostraStatus(Port,'(OnSilenceDetected) - Silncio...');

    //Desliga a porta
    nRet := voicerlib1.HangUp(Port);
    if nRet = DG_EXIT_SUCCESS then  
      MostraStatus(Port, '(OnSilenceDetected) - Desligou a porta')
    else
      MostraStatus(Port,'(OnSilenceDetected) - Erro ao desligar a porta.nRet ' + IntToStr(nRet)); 
  
    //Desabilita supervisao de linha
    nRet := voicerlib1.DisableCallProgress(Port); 
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnSilenceDetected) - Erro ao desabilitar superviso de linha.nRet ' + IntToStr(nRet)) ;

    //Desabilita deteccao de silencio
    nRet := voicerlib1.DisableSilenceDetection(Port);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'(OnSilenceDetected) - Erro ao desabilitar a deteco de silncio.nRet ' + IntToStr(nRet)) ;

  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  nRet : Integer;
  cVersao : array[0..255] of Char;
begin

  //Verifica a versao da dll e ocx da voicerlib
  nRet := voicerlib1.GetLibVersion(Cardinal(@cVersao),0);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso DLL -> ' + cVersao)
  else
    MostraStatus(0,'Verso DLL -> Falha');

  nRet := voicerlib1.GetLibVersion(Cardinal(@cVersao),1);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso OCX -> ' + cVersao)
  else
    MostraStatus(0,'Verso OCX -> Falha');

  if DirectoryExists('\Arquivos de Programas') then
      voicerlib1.ConfigPath := '\Arquivos de Programas\VoicerLib4'
  else
  begin
    if DirectoryExists('\Program Files') then
      voicerlib1.ConfigPath := '\Program Files\VoicerLib4'      
  end;

end;

end.
